// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// VCSProvider is an autogenerated mock type for the VCSProvider type
type VCSProvider struct {
	mock.Mock
}

// CreateProvider provides a mock function with given fields: ctx, input
func (_m *VCSProvider) CreateProvider(ctx context.Context, input *types.CreateVCSProviderInput) (*types.CreateVCSProviderResponse, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.CreateVCSProviderResponse
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateVCSProviderInput) (*types.CreateVCSProviderResponse, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateVCSProviderInput) *types.CreateVCSProviderResponse); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.CreateVCSProviderResponse)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateVCSProviderInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteProvider provides a mock function with given fields: ctx, input
func (_m *VCSProvider) DeleteProvider(ctx context.Context, input *types.DeleteVCSProviderInput) (*types.VCSProvider, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.VCSProvider
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteVCSProviderInput) (*types.VCSProvider, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteVCSProviderInput) *types.VCSProvider); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.VCSProvider)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.DeleteVCSProviderInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProvider provides a mock function with given fields: ctx, input
func (_m *VCSProvider) GetProvider(ctx context.Context, input *types.GetVCSProviderInput) (*types.VCSProvider, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.VCSProvider
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetVCSProviderInput) (*types.VCSProvider, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetVCSProviderInput) *types.VCSProvider); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.VCSProvider)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetVCSProviderInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateProvider provides a mock function with given fields: ctx, input
func (_m *VCSProvider) UpdateProvider(ctx context.Context, input *types.UpdateVCSProviderInput) (*types.VCSProvider, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.VCSProvider
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateVCSProviderInput) (*types.VCSProvider, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateVCSProviderInput) *types.VCSProvider); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.VCSProvider)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.UpdateVCSProviderInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewVCSProvider interface {
	mock.TestingT
	Cleanup(func())
}

// NewVCSProvider creates a new instance of VCSProvider. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewVCSProvider(t mockConstructorTestingTNewVCSProvider) *VCSProvider {
	mock := &VCSProvider{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
